summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-08-27 19:41:04 +0000
committerJim Meyering <jim@meyering.net>2006-08-27 19:41:04 +0000
commit520a954d7e8823a4c385c662b3b571ae53f125ea (patch)
treed62505143c782bebd736615f4d44a27db01e0694 /tests/cp
parent07446625096ddeb9246fb36572d5fe644f56cd1f (diff)
downloadcoreutils-520a954d7e8823a4c385c662b3b571ae53f125ea.tar.xz
* src/copy.c (copy_internal): Don't make a backup if the last
component of the source name is "." or "..". Reported by Andreas Schwab in https://savannah.gnu.org/bugs/?17540. * tests/cp/src-base-dot: New file. Test for the above fix. * tests/cp/Makefile.am (TESTS): Add src-base-dot.
Diffstat (limited to 'tests/cp')
-rw-r--r--tests/cp/Makefile.am1
-rwxr-xr-xtests/cp/src-base-dot54
2 files changed, 55 insertions, 0 deletions
diff --git a/tests/cp/Makefile.am b/tests/cp/Makefile.am
index 5b4c23606..dd758404f 100644
--- a/tests/cp/Makefile.am
+++ b/tests/cp/Makefile.am
@@ -21,6 +21,7 @@
AUTOMAKE_OPTIONS = 1.1 gnits
TESTS = \
+ src-base-dot \
sparse \
link-no-deref \
cp-deref \
diff --git a/tests/cp/src-base-dot b/tests/cp/src-base-dot
new file mode 100755
index 000000000..4b4a586da
--- /dev/null
+++ b/tests/cp/src-base-dot
@@ -0,0 +1,54 @@
+#!/bin/sh
+# Ensure that "mkdir x y; cd y; cp -ab ../x/. ." is a successful, silent, no-op.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+mkdir x y || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+cd y
+cp --verbose -ab ../x/. . > out 2>&1 || fail=1
+cat <<\EOF > exp || fail=1
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail